--------------------------------------------------------------------------
-- Assirc_Database                          Copyrigth ENS ULM 1996-1998 --
-- Pierre VINCENS                   V 00.000                 10/04/1996 --
-- Pierre VINCENS                   V 01.000                 31/03/1998 --
--------------------------------------------------------------------------
-- Gestion de la base de donnes des fragments similaires 
-- Cette partition gre un arbre contenant l'ensemble des paires trouves
-- NOTES:
--   1/ La base est maintenue interne  ce paquetage. Toutes les oprations
--      sur la base doivent donc se faire via cette interface. La gestion
--      se fait sous la forme d'un arbre unique.
--   2/ Ce paquetage est destin  tre utilis exclusivement par la 
--      version non distribue. L'accs aux donnes doit imprativement
--      tre protg dans la version distribue. L'quivalent de ce paquetage
--      est alors Dassirc_Database.
--------------------------------------------------------------------------
with Type_Specifications; use Type_Specifications;

with Assirc_Specifications; use Assirc_Specifications;
with Assirc_Specifications.Database; use Assirc_Specifications.Database;

package Assirc_Database is

  procedure Set_Parameters(Excluded_Marge     : in Integer;
			   Intersection_Marge : in Integer);
  pragma Inline(Set_Parameters);
  -- Enregistrement des paramtres de gestion de la base de donnes

  function Included(Seg1,Seg2 : in Segment_Type) return Boolean;
  pragma Inline(Included);
  -- Test de la prsence d'une graine dans l'arbre.

  procedure Append_Pair_In_Tree(Pair : in out Segment_Pair);
  pragma Inline(Append_Pair_In_Tree);
  -- Ajout d'une paire dans l'arbre
  
  procedure Print_Database(Name : in String;
			   Minimal_Length : in Integer);
  pragma Inline(Print_Database);
  -- Impression de la base de donnes des rgions similaires supposes

  procedure Reset_Tree;
  pragma Inline(Reset_Tree);
  -- Rinitialisation de la base de donnes. Toutes les donnes
  -- sont effaces.

  generic
    with procedure Command(Pair : in out Segment_Pair);
  procedure Apply_To_Tree;
  pragma Inline(Apply_To_Tree);
  -- Application de la procdure commande  chaque lment de la base de dones

private

  -- Les variables de gestion de la base definies dans la partie
  -- prive pour etre accessible aux package fils

  Similar_Regions : Similar_Regions_Tree;
  -- L'arbre des segments homologues
  Excluded : Integer := 10;
  -- Le pourcentage d'exclusion en bout de chaque fragment pour dcider de
  -- la nouvelle expension d'une zone
  Intersection : Integer := 50;
  -- Le nombre de base maximum pouvant spar deux paires pour considrer
  -- qu'il s'agit de la mme rgion d'homologie

end Assirc_Database;
