--------------------------------------------------------------------------
-- Assirc_Seeds.D_Eval_M3                   Copyrigth ENS ULM 1996-1998 --
-- Pierre VINCENS                   V 00.000                 10/04/1996 --
-- Pierre VINCENS                   V 01.000                 31/03/1998 --
-- Pierre VINCENS                   V 01.001                 17/04/1998 --
-- Pierre VINCENS                   V 01.002                 23/06/1999 --
--------------------------------------------------------------------------
-- Evaluation des graines (Version distribue M3)
-- Dans cette version, il y a transmission des graines  tester  la base 
-- de donnes. Celles-ci mmorisent celles qui doivent tre tendus et
-- les mets  la disposition des clients pour tre testes.
--------------------------------------------------------------------------
-- V 01.001
-- Les evolutions portent sur:
--   1/ L'echange des paires entre la base de donnees et ce module se fait
-- par paquet reduisant ainsi le nombre de transactions
--   2/ Le controle de la determination des paires a tester en fonction des
-- brins a analyser a ete integre. Le calcul des paires est fait lors de
-- l'appel de Set_Pairs_To_Check. C'est un prealable a l'appel de 
-- Product_Seeds.
--   3/ L'appel de Product_Seeds a ete modifie (sequences est maintenant un 
-- pointeur sur le tableau et non plus le tableau lui-meme).
--------------------------------------------------------------------------
-- V 01.002
-- Le systme gre mainetnant une base de donnes locale dans laquelle
-- sont enregistr toutes les paires dtectes dans la partition. Cette
-- base n'est utile que lorsqu'il y a production de graines localement.
-- La procedure Close_Local_Database permet de desactiver la fonction
-- d'enregistrement des graines localement. Elle doit etre appele
-- lorsque dans une partition, il n'y aura plus de production de
-- nouvelles graines.
--------------------------------------------------------------------------

package Assirc_Seeds.D_Eval_M3 is

  procedure Set_Pairs_To_Check(Sequences: in Assirc_Sequence_Array_Access);
  procedure Reset_Pairs_To_Check;
  pragma Inline(Set_Pairs_To_Check,Reset_Pairs_To_Check);
  -- La premiere procedure realise la determination des paires a considerer
  -- en fonction des brins a traiter. La seconde remet a zero la table. Il
  -- est imperatif d'avoir appele Set_Pairs_To_Check avant d'appeler
  -- Product_Seeds

  procedure Product_Seeds(Seeds           : in out Seed_Segments;
                          Common_Max_Dist : in Integer;
                          Xonly           : in Boolean);
  pragma Inline(Product_Seeds);
  -- Production des graines  tester

  procedure Expand_Seeds(Sequences       : in Assirc_Sequence_Array_Access;
                         Min_Length      : in Integer;
                         Max_Dist        : in Integer;
                         Tolerance       : in Integer;
                         Common_Max_Dist : in Integer;
                         Skip            : in Integer);
  pragma Inline(Expand_Seeds);
  -- Dtermination de la similarit de la rgion se trouvant autour
  -- de chaque graine par une mthode d'extension mesurant la distance
  -- sparant des marches alatoires

end Assirc_Seeds.D_Eval_M3;
