--------------------------------------------------------------------------
-- Assirc_Seeds                             Copyrigth ENS ULM 1996-1998 --
-- Pierre VINCENS                   V 01.000                 14/05/1998 --
--------------------------------------------------------------------------
with Type_Specifications; use Type_Specifications;
with Sequence_Specifications; use Sequence_Specifications;


package body Assirc_Seeds_Util is

  procedure Swap(X,Y : in out Integer) is
    Tampon : Integer := X;
  begin
    X := Y;
    Y := Tampon;
  end Swap;

  function Tnu(Strand : in Strand_Type; Nucleotide: in Nucleotide_Type) 
    return Integer is

    type Tnu_Array is array(Watson..Crick,
			    Nucleotide_Type'('A')..Nucleotide_Type'('C'))
      of Integer;
    Convert : constant Tnu_Array := 
      (Watson => ('A'=>0, 'T'=>1, 'G'=>2, 'C'=>3), 
       Crick  => ('A'=>1, 'T'=>0, 'G'=>3, 'C'=>2));
  begin
    if Nucleotide > 'C' then
      raise UNDEFINED_NUCLEOTIDE;
    end if;
    return Convert(Strand,Nucleotide);
  end Tnu;

  procedure New_Shift(Nuc    : in Nucleotide_type;
		      Shift  : in Shift_Type;
		      V      : in out Vector) is
  begin
    for I in V'Range loop
      V(I) := V(I) + Shift(Nuc,I);
    end loop;
    --       V(V'First) := V(V'First) + Params.Shift(Strand)(Nuc,V'First);
    --       V(V'Last) := V(V'Last) + Params.Shift(Strand)(Nuc,V'Last);
  end New_Shift;
  
  function Distance_2(V1,V2 : in Vector) return Integer is
    Sum : Integer := 0;
  begin
    for I in V1'Range loop
      Sum := Sum + (V1(I) - V2(I)) ** 2;
    end loop;
    return Sum;
    --       return (V1(V1'First) - V2(V2'First)) ** 2 + 
    -- 	     (V1(V1'Last) - V2(V2'Last)) ** 2;
  end Distance_2;

end Assirc_Seeds_Util;
