--------------------------------------------------------------------------
-- Assirc_Seeds                             Copyrigth ENS ULM 1996-1998 --
-- Pierre VINCENS                   V 01.000                 14/05/1998 --
--------------------------------------------------------------------------
-- Utilitaires associs au paquetage Assirc_Seeds mis ici pour pouvoir  --
-- etre dclar comme pure et obtenir ainsi une optimisation meilleure  --
--------------------------------------------------------------------------
with Type_Specifications; use Type_Specifications;
with Sequence_Specifications; use Sequence_Specifications;
with Assirc_Specifications; use Assirc_Specifications;


package Assirc_Seeds_Util is

  pragma Pure;

  UNDEFINED_NUCLEOTIDE : exception;

--------------------------------------------------------------------------
-- Echange de deux entiers                                              --
--------------------------------------------------------------------------
  procedure Swap(X,Y : in out Integer);
  pragma Inline(Swap);
    
--------------------------------------------------------------------------
-- Conversion des nucleotides en entier pour le hash-coding             --
--------------------------------------------------------------------------
  function Tnu(Strand : in Strand_Type; Nucleotide: in Nucleotide_Type) 
	       return Integer;
  pragma Inline(Tnu);

--------------------------------------------------------------------------
-- Primitives de calcul des distances                                   --
--------------------------------------------------------------------------
  type Vector is array(Integer range <>) of Integer;
  -- vecteur dcrivant la position sur le chemin de la marche alatoire

  procedure New_Shift(Nuc    : in Nucleotide_type;
		      Shift  : in Shift_Type;
		      V      : in out Vector);
  pragma Inline(New_Shift);
  -- Calcul d'un dplacement

  function Distance_2(V1,V2 : in Vector) return Integer;
  pragma Inline(Distance_2);
  -- Calcul de la distance entre deux vecteurs

end Assirc_Seeds_Util;
