--------------------------------------------------------------------------
-- Assirc_Statistics                        Copyrigth ENS ULM 1996-1998 --
-- Pierre VINCENS                   V 01.000                 06/04/1998 --
--------------------------------------------------------------------------
-- enregistrement des statistiques de recherche des graines
--------------------------------------------------------------------------


package Assirc_Statistics is

  protected Statistics is
    procedure Increment_Constituted;
    procedure Increment_Tested;
    procedure Increment_Registered;
    procedure Increment_Validated;
    -- Incrmenter les compteurs respectifs
    procedure Increment_Constituted(Count : in Natural);
    procedure Increment_Tested(Count : in Natural);
    procedure Increment_Registered(Count : in Natural);
    procedure Increment_Validated(Count : in Natural);
    -- Incrmenter les compteurs respectifs de count units
    procedure Get_Statistics(Constituted : out Natural;
			     Tested      : out Natural;
			     Registered  : out Natural;
			     Validated   : out Natural);
    -- Obtention des statistiques enregistres
  private
    Constituted : Natural := 0; 
    -- Nombre de couples constitus
    Tested      : Natural := 0; 
    -- Nombre de couples tests (validit + inclusion)
    Registered  : Natural := 0; 
    -- Nombre de couples dont l'enregistrement dans la base de donnes  
    -- est demand (avant concatenation)
    Validated   : Natural := 0;
    -- Nombre de couples pour lequel un alignement a t ralis
  end Statistics;

end Assirc_Statistics;
