--------------------------------------------------------------------------
-- Cpu_Times.Basic                          Copyrigth ENS ULM 1998-1998 --
-- Pierre VINCENS                   V 01.000                 03/04/1998 --
--------------------------------------------------------------------------
-- Obtention des temps cpu associ  un process. L'origine des temps
-- est prise lors de l'laboration du paquetage.
-- ATTENTION: ce paquetage est systme dpendant
--------------------------------------------------------------------------
with Ada.Calendar; use Ada.Calendar;

package Cpu_Times.Basic is

  function Elapsed_Real_Time return Duration;
  pragma Inline(Elapsed_Real_Time);
  -- Donne le temps rel coul depuis l'laboration du paquetage

  function Elapsed_Cpu_Time return Duration;
  pragma Inline(Elapsed_Cpu_Time);
  -- Donne le temps CPU total (user+system) coul depuis le dbut du process

  function Elapsed_Times return Cpu_Duration;
  pragma Inline(Elapsed_Times);
  -- Donne les temps CPU (real+user+system) coul depuis le dbut du process

  function Date_To_String return String;
  function Date_To_String(Date : in Time) return String;
  function Time_To_String return String;
  function Time_To_String(Date : in Time) return String;
  function Time_To_String(Times : in Duration) return String;
  pragma Inline(Date_To_String,Time_To_String);
  -- Formatage de la date et de l'heure

  procedure Print_Times;
  -- Imprime les temps couls depuis le dbut du process. L'affichage
  -- dpend du systeme sur lequel on se trouve.
  
end Cpu_Times.Basic;
