--------------------------------------------------------------------------
-- Cpu_Times.Counters                       Copyrigth ENS ULM 1996-1998 --
-- Pierre VINCENS                   V 01.000                 13/03/1998 --
--------------------------------------------------------------------------
-- Ce paquetage permet de recuperer le temps d'execution du programme
-- sous linux, chaque tache s'executant sous un process different.
-- 
--------------------------------------------------------------------------
with Ada.Text_Io; use Ada.Text_Io;
with Ada.Calendar;

with System_Constants; use System_Constants;

with Type_Specifications; use Type_Specifications;
with Cpu_Times; use Cpu_Times;
with Cpu_Times.Basic; use Cpu_Times.Basic;
with Cpu_Times.Utilities; use Cpu_Times.Utilities;

package body Cpu_Times.Counters is

--------------------------------------------------------------------------
-- Un type protg pour memoriser la liste des process                  --
--------------------------------------------------------------------------

  protected body Cpu_Counters is 
    procedure Add(Key : in String) is
    begin
      case Operating_System is
	when Linux   => Add_Pid_In_List(Pid_List,Key);
	when Solaris => null;
	when Windows => null;
      end case;
    end Add;
      
    procedure Remove is
    begin
      case Operating_System is
      	when Linux   => Remove_Pid_From_List(Pid_List);
	when Solaris => null;
	when Windows => null;
      end case;
    end Remove;

    procedure Update_Childs is
    begin
      case Operating_System is
      	when Linux   =>
	  -- On lance deux fois l'appel pour avoir accs aux petits fils
	  -- Il ne semble pas y avoir de profondeur d'appel suprieure  2
	  Add_Childs(Pid_List);
	  Add_Childs(Pid_List);
	when Solaris => null;
	when Windows => null;
      end case;
    end Update_Childs;

    procedure Print_Process_List is
    begin
      case Operating_System is
      	when Linux   => Print_Process_List(Pid_List);
	when Solaris => null;
	when Windows => null;
      end case;
    end Print_Process_List;

    procedure Print_Elapsed_Times is
      Times : Cpu_Duration;
    begin
      case Operating_System is
      	when Linux   => Elapsed_times(Pid_List,Times);
	when Solaris => Times := Elapsed_Times;
	when Windows => Times := Elapsed_Times;
      end case;
      Print_Elapsed_Times(Pid_List);
    end Print_Elapsed_Times;

    procedure Elapsed_Times(Times : in out Cpu_Duration) is
    begin
      case Operating_System is
      	when Linux   => Elapsed_times(Pid_List,Times);
	when Solaris => Times := Elapsed_Times;
	when Windows => Times := Elapsed_Times;
      end case;
    end Elapsed_Times;

  end Cpu_Counters; 

end Cpu_Times.Counters;
