--------------------------------------------------------------------------
-- Dassirc_Abort                            Copyrigth ENS ULM 1996-2000 --
-- Pierre VINCENS                   V 01.000                 12/12/2000 --
--------------------------------------------------------------------------
-- Desactivation d'un client Builder
--------------------------------------------------------------------------
with Ada.Text_Io; use Ada.Text_Io;
with Ada.Calendar; use Ada.Calendar;

with Type_Specifications; use Type_Specifications;

with Dassirc_Common; use Dassirc_Common;
with Dassirc_Dispatcher; use Dassirc_Dispatcher;

with Dassirc_Abort_Options; use Dassirc_Abort_Options;

procedure Dassirc_Abort is
  
  Options : Abort_Options;
  Answer  : Character;
  
begin
  Get_Options(Options);
  if Options.Client = Unassigned_Id then
    raise Argument_Error;
  elsif Options.Client < First_Client_Id then
    Put_Line("Sorry, this function only allows to kill builder clients");
  else
    Put("Are you sure to abort client " & 
	View_Id'Image(Options.Client) & " (y/n) : ");
    Get(Answer);
    Put_Line("Answer = " & Answer);
    if answer = 'y' or Answer = 'Y' then
      Dassirc_Dispatcher.Client_Aborting(Options.Client);
      Put_Line("Client " & View_Id'Image(Options.Client) &
	       " has been aborted");
    else
      Put_Line("OK..." & View_Id'Image(Options.Client) &
	       " is always running");
    end if;
  end if;
exception
  when DISPATCHER_COMPLETED =>
    Put_Line("Dassirc completed");
  when ARGUMENT_ERROR =>
    Print_Options;
end Dassirc_Abort;
