--------------------------------------------------------------------------
-- Dassirc_Abort_Options                    Copyrigth ENS ULM 1996-2000 --
-- Pierre VINCENS                   V 01.000                 12/12/2000 --
--------------------------------------------------------------------------
with Ada.Text_Io; use Ada.Text_Io;
with Ada.Command_Line; use Ada.Command_Line;
with Options_Util; use Options_Util;

package body Dassirc_Abort_Options is
  
  procedure Get_Options(Options : in out Abort_Options) is
      Count : Positive := 1;
  begin
    Put_Line("Nb options : " & Integer'Image(Argument_Count));
    if Argument_Count = 0 then
      raise ARGUMENT_ERROR;
    end if;
    while Count <= Argument_Count loop
      if Is_An_Alias(Argument(Count),"-CLIENT",2) then
        -- Identificateur du Client
	Count := Count + 1;
	declare
	  Value : Integer := Opt_Int(Argument(Count));
	begin
	  if Value < 0 or Value > Integer(Max_View_Id) then
	    raise ARGUMENT_ERROR;
	  else
	    Options.Client := View_Id(Value);
	  end if;
	exception
	  when Constraint_Error | Data_Error =>
	    raise ARGUMENT_ERROR;
	end;
      elsif Is_An_Alias(Argument(Count),"--BOOT_SERVER",13) then
        -- Cette option est utilise par Glade en version distribue
        -- pour prciser le numro du port de la socket
        -- On l'ignore ainsi que la valeur de la socket donne 
	-- en argument suivant
        Count := Count + 1;
      elsif Is_An_Alias(Argument(Count),"--SLAVE",7) then
        -- Cette option est utilise par Glade en version distribue
        -- pour indiquer qu'il s'agit d'un process esclave. On l'ignore.
        null;
      else
        -- raise ARGUMENT_ERROR;
	Put_Line("Invalid options value: " & Argument(Count));
      end if;
      Count := Count + 1;
    end loop;

  end Get_Options;

  procedure Print_Options is
  begin
    Put_Line("DASSIRC_ABORT: argument error");
    Put_Line("    syntax is: dassirc_abort -Client Id");
    New_Line;
  end Print_Options;

end Dassirc_Abort_Options;
