--------------------------------------------------------------------------
-- Dassirc_Channel                          Copyrigth ENS ULM 1996-1998 --
-- Pierre VINCENS                   V 01.000                 23/03/1998 --
--------------------------------------------------------------------------
-- Ce paquetage prend en charge le transfer des squences entre le
-- dispatcher et les clients.
--------------------------------------------------------------------------
with Sequence_Specifications; use Sequence_Specifications;
with Sequence_Specifications.Basic; use Sequence_Specifications.Basic;

with Sockets; use Sockets;

package Dassirc_Channel is
  
  Unavailable_Socket : exception;
  -- Indique l'impossibilite d'ouvrir une socket
    
  procedure Open_Input_Connection(Accepting_Socket : in out Socket_FD;
				  Port             : in out Positive);
  -- Initialisation de la socket. Si le port demande n'est pas libre
  -- on tente une connexion sur un port de numro suprieur;

  procedure Receive_Sequence(Sequence : in Nucleotidic_Sequence;
			     Accepting_Socket : in out Socket_FD);
  -- Rception de la squence. Open_Input_Connection doit avoir
  -- t appel pralablement, et Close_Input_Connection devra
  -- etre appel aprs pour clore la connexion. Il est possible
  -- d'enchainer plusieurs Receive_Sequence successifs.

  procedure Close_Input_Connection(Accepting_Socket : in out Socket_FD);
  -- Fermeture de la socket

  procedure Send_Sequence(Sequence : in Nucleotidic_Sequence;
			  From,To  : in Natural;
			  Host     : in String;
			  Port     : in Positive);
  -- Envoi d'une squence sur le (host,port) indiqu
  -- Si Unavailable_Socket est leve, il s'agit probablement d'un
  -- probleme lie a un nombre de descripteurs ouverts insuffisant
  -- Faire un limits descriptors 128 (ou plus) au niveau du shell
  -- de lancement du serveur
  

end Dassirc_Channel;
