--------------------------------------------------------------------------
-- Dassirc_Statistics                       Copyrigth ENS ULM 1996-2000 --
-- Pierre VINCENS                   V 01.000                 29/11/2000 --
--------------------------------------------------------------------------
-- Paquetage RCI auquel se connecte les clients pour memoriser l'etat
-- d'avancement de la recherche
--------------------------------------------------------------------------
with Type_Specifications; use Type_Specifications;

with Sequence_Specifications; use Sequence_Specifications;

with Sequence_Alignment; use Sequence_Alignment;

with Assirc_Specifications; use Assirc_Specifications;

with Dassirc_Common; use Dassirc_Common;

package Dassirc_Statistics is

  pragma Remote_Call_Interface;
  
  procedure Start;
  -- L'appel de cette procedure est fait par le manager. Elle
  -- permet d'initialiser la table des etats des processus.

  procedure Stop;
  -- L'appel de cette procdure indique la terminaison du module
  
  procedure Connect(Id : in View_Id);
  -- Indique la connexion d'un nouveau client
  -- Ceci est normalement fait uniquement par le dispatcher
  
  procedure disconnect(Id : in View_Id);
  -- Indique qu'un client a ete deconnecte
  -- Ceci est normalement fait uniquement par le dispatcher
  
  procedure Advancement(Id    : in View_Id; 
                        State : in Partition_State);
  -- La partition informe le dispatcher de son tat d'avancement

  procedure Set_Status(Id     : in View_Id; 
		       Status : in Status_Type);
  -- Pour positionner le status pour une partition donnee
  -- Ceci est normalement fait uniquement par le dispatcher

  function Get_Status(Id      : in View_Id) return Status_Type;
  -- Retourne la valeur du status pour une partition donnee

  function State return Partition_State_Array;
  -- Le moniteur peut obtenir les informations sur les partitions


end Dassirc_Statistics;  
