--------------------------------------------------------------------------
-- Options_Util                             Copyrigth ENS ULM 1986-1999 --
-- Pierre VINCENS                   V 01.000                 26/07/1996 --
-- Pierre VINCENS                   V 01.001                 04/03/1999 --
--------------------------------------------------------------------------
-- Utilitaire de gestion des options d'un programme
--------------------------------------------------------------------------
-- V 01.001
-- Ajout de Opt_Sequence_Model
--------------------------------------------------------------------------
with Type_Specifications; use  Type_Specifications;
with Sequence_Specifications; use  Sequence_Specifications;
with Strlib; use  Strlib;


package Options_Util is

  ARGUMENT_ERROR : exception;

  function Upcase(Value : in String) return String;
    -- Cette fonction transforme les caracteres minuscules
    -- en caracteres majuscules.


  function Is_An_Alias(Value : in String;
                       Name  : in String;
                       Min   : in Natural := 2) return Boolean;
    -- cette fonction retourne vrai si la chaine value s'inscrit dans
    -- la chaine name. La chaine value doit comporter au moins les min
    -- premiers caracteres. On ne tient pas compte des lettres
    -- minuscules ou majuscules.

  function Root_Name(Src: in String) return String;
  function Root_Name(Src: in Varstring) return String;
    -- Cette fonction extrait la racine d'un nom de fichier

  function Opt_Int(Str : in String) return Integer;
  function Opt_Real(Str : in String) return Real;
  function Opt_Sequence_Format(Str : in String) return Sequence_Format;
  function Opt_Sequence_Model(Str : in String) return Sequence_Model;
  function Opt_Sequence_Strand(Str : in String) return Strand_Type;
    -- Ces fonctions analysent les valeurs des options correspondantes

end Options_Util;
