--------------------------------------------------------------------------
-- Sequence_Alignment.Basic                 Copyrigth ENS ULM 1996-1999 --
-- Pierre VINCENS                   V 01.000                 02/06/1999 --
--------------------------------------------------------------------------
with Ada.Unchecked_Deallocation;

package body Sequence_Alignment.Basic is  

  procedure Free(Alignment : in out Alignment_Access) is
    procedure Dispose is new Ada.Unchecked_Deallocation(Alignment_Model,
							Alignment_Access);
  begin
    Clear(Alignment.Name1);
    Clear(Alignment.Name2);
    Clear(Alignment.Seq1);
    Clear(Alignment.Seq2);
    Dispose(Alignment);
  end Free;

  procedure Free(Alignments : in out Alignments_Access) is 
    procedure Dispose is new Ada.Unchecked_Deallocation(Alignments_Array,
							Alignments_Access);
  begin
    for I in Alignments'Range loop
      Free(Alignments(I));
    end loop;
    Dispose(Alignments);
  end Free;

  function To_Alignment_Summary(Alignment: in Alignment_Model) 
				return Alignment_Summary_Model is
    Summary : Alignment_Summary_Model;
  begin
    -- Recopie du nom
    Put_The_N_Last_Characters(Summary.Name1,Alignment.Name1);
    Put_The_N_Last_Characters(Summary.Name2,Alignment.Name2);
    -- Recopie du brin
    Summary.Strand1              := Alignment.Strand1;
    Summary.Strand2              := Alignment.Strand2;
    -- methode utilise pour realiser l'Alignment
    Summary.Method               := Alignment.Method;
    -- quantificateur de l'Alignment realise
    Summary.Quality              := Alignment.Quality;
    Summary.Quality_Mean         := Alignment.Quality_Mean;
    Summary.Quality_Std          := Alignment.Quality_Std;
    Summary.Quality_Zscore       := Alignment.Quality_Zscore;
    Summary.Quality_Sng          := Alignment.Quality_Sng;
    Summary.Ratio                := Alignment.Ratio;
    Summary.Similarity           := Alignment.Similarity;
    Summary.Identity             := Alignment.Identity;
    Summary.Length               := Alignment.Length;
    Summary.Nb_Match             := Alignment.Nb_Match;
    Summary.Nb_Mismatch          := Alignment.Nb_Mismatch;
    Summary.Nb_Gaps              := Alignment.Nb_Gaps;
    Summary.Gaps_Length          := Alignment.Gaps_Length;
    Summary.Max_Continuous_Match := Alignment.Max_Continuous_Match;
    -- les positions de depart et de fin dans les squence initiales
    Summary.Start1               := Alignment.Start1;
    Summary.Stop1                := Alignment.Stop1;
    Summary.Start2               := Alignment.Start2;
    Summary.Stop2                := Alignment.Stop2;
    return Summary;
  end To_Alignment_Summary;

end Sequence_Alignment.Basic;
