--------------------------------------------------------------------------
-- Sequence_Alignment.Local                 Copyrigth ENS ULM 1996-1997 --
-- Pierre VINCENS                   V 00.000                 03/12/1997 --
--------------------------------------------------------------------------
-- Determination d'un alignement local optimal tel que defini par
-- Smith et Waterman
--------------------------------------------------------------------------
with Options_Util; use  Options_Util;
with Strlib; use  Strlib;
with Type_specifications; use Type_Specifications;

with Sequence_Specifications; use Sequence_Specifications;
with Sequence_Specifications.Basic; use Sequence_Specifications.Basic;

with Sequence_Alignment.Basic; use Sequence_Alignment.Basic;

with Unchecked_Deallocation;

package Sequence_Alignment.Local is

  procedure Perform_Local_Alignment
    (Sequence1            : in Sequence_Data;
     Sequence2            : in Sequence_Data;
     Alignments           : in out Alignments_Access;
     From1,To1            : in Integer := Complete;
     From2,To2            : in Integer := Complete;
     Matrix               : in String  := "";
     Match_Weight         : in Integer := 100;
     Mismatch_Weight      : in Integer := -90;
     Gap_Weight           : in Integer := -500;
     Gap_Length_Weight    : in Integer := -30;
     Progression          : in Progression_Method := DVH;
     Building             : in Building_Method := All_Firsts;
     Optimize             : in Optimize_Method := No;
     Similarity_Threshold : in Integer := -1;
     Randomization        : in Integer := 0;
     Preserve             : in Integer := 1);
  
  -- Le paramtre Similarity_Threshold dfinit le seuil pour considrer
  -- que deux rsidus sont similaires. Une valeur ngative provoque
  -- une estimation automatique selon la rgle: moyenne de toutes les
  -- valeurs positives de la matrice pour des rsidus non identiques

end Sequence_Alignment.Local;
