--------------------------------------------------------------------------
-- Sequence_IO                              Copyrigth ENS ULM 1986-1997 --
-- Pierre VINCENS                   V 01.000                 06/11/1997 --
-- Pierre VINCENS                   V 01.001                 05/03/1999 --
--------------------------------------------------------------------------
--
-- Paquetage incluant les fonctions de lecture des squences
--
--------------------------------------------------------------------------
-- V 01.001
-- Ajout des fonctions de lecture des squences protiques
-- Support d'une lecture directe dans les champs amino_acids et nucleotides
-- spcifi par l'usage du champ field.
--------------------------------------------------------------------------
with Sequence_Specifications; use  Sequence_Specifications;
with Sequence_Specifications.Basic; use  Sequence_Specifications.Basic;

package Sequence_Io is

  SEQUENCE_IO_ERROR : exception;
  -- Levee si il y a une erreur de lecture dans une sequence

  type Field_Mode is (Internal,External);
  -- Permet de spcifier si on souhaite lire la sequence dans le
  -- champ composition comme une chaine de caractres (external) ou
  -- dans les champs Nucleotides ou Amino_Acids comme un tableau
  -- de nucleotides ou d'acides amins (Internal)

  procedure Read_Sequence(Name     : in String;
                          Sequence : in out Sequence_Data'Class;
                          Model    : in Sequence_Model;
                          Format   : in Sequence_Format := Plain_Ascii;
			  Field    : in Field_Mode := External);

end Sequence_Io;
