--------------------------------------------------------------------------
-- Sequence_Specifications.Utils            Copyrigth ENS ULM 1986-2004 --
-- Pierre VINCENS                   V 01.000                 01/03/2004 --
--------------------------------------------------------------------------
with Ada.Text_Io; use Ada.Text_Io;
with Ada.Numerics.Discrete_Random;

package body Sequence_Specifications.Utils is
  
  package Integer_Random is new Ada.Numerics.Discrete_Random(Integer);
  use Integer_Random;
  Integer_Generator : Integer_Random.Generator;
  
  procedure Shuffle(Sequence : in out Nucleotidic_Array;
		    Preserve : in Integer := 1) is
    subtype Position is Integer range Sequence'Range;
    package Position_Random is new Ada.Numerics.Discrete_Random(Position);
    use Position_Random;
    Position_Generator : Position_Random.Generator;
    
    P1,P2  : Position;
    Tampon : Nucleotide_Type;
  begin
    Reset(Position_Generator,Random(Integer_Generator));
    -- echange au hasard de positions
    for I in 1..Sequence'Length loop
      P1 := Random(Position_Generator);
      P2 := Random(Position_Generator);
      Tampon := Sequence(P1);
      Sequence(P1) := Sequence(P2);
      Sequence(P2) := Tampon;
    end loop;
  end Shuffle;
  
  procedure Shuffle(Sequence : in out Amino_Acids_Array) is
    subtype Position is Integer range Sequence'Range;
    package Position_Random is new Ada.Numerics.Discrete_Random(Position);
    use Position_Random;
    Position_Generator : Position_Random.Generator;
    
    P1,P2  : Position;
    Tampon : Amino_Acid_Type;
  begin
    Reset(Position_Generator,Random(Integer_Generator));
    -- echange au hasard de positions
    for I in 1..Sequence'Length loop
      P1 := Random(Position_Generator);
      P2 := Random(Position_Generator);
      Tampon := Sequence(P1);
      Sequence(P1) := Sequence(P2);
      Sequence(P2) := Tampon;
    end loop;
  end Shuffle;
  
begin
  Reset(Integer_Generator);
end Sequence_Specifications.Utils;

