--------------------------------------------------------------------------
-- Strlib.IO                                Copyrigth ENS ULM 1986-1999 --
-- Pierre VINCENS                   V 01.000                 06/11/1997 --
-- Pierre VINCENS                   V 01.001                 19/03/1999 --
--------------------------------------------------------------------------
--
-- Paquetage de gestion des entres-sorties de chaines de caracteres
-- sous une forme dynamique
--
--------------------------------------------------------------------------
-- V 01.001
-- Ajout des procdures Put_The_N_Last_Characters
--------------------------------------------------------------------------
with Ada.Text_Io; use Ada.Text_Io;

package Strlib.IO is

--===========================================================================
-- Fonctionnalites d'entree-sortie (utilise text_io)
--===========================================================================
  procedure Put(Varstr : in Varstring);
  procedure Put(File : in File_Type; Varstr : in Varstring);

  procedure Put_Line(Varstr : in Varstring);
  procedure Put_Line(File : in File_Type; Varstr : in Varstring);

  procedure Put_The_N_Last_Characters(Str    : in String;
                                      N      : in Integer);
  procedure Put_The_N_Last_Characters(Varstr : in Varstring;
                                      N      : in Integer);
  procedure Put_The_N_Last_Characters(File   : in File_Type;
                                      Str    : in String;
                                      N      : in Integer);
  procedure Put_The_N_Last_Characters(File   : in File_Type;
                                      Varstr : in Varstring;
                                      N      : in Integer);
  -- Imprime les N derniers caractres de la chaine cadrs  gauche

  procedure Get(Varstr : in out Varstring;
                Length : in Positive;
                Mode   : in End_Mode := Normal);
  procedure Get(File   : in File_Type;
                Varstr : in out Varstring;
                Length : in Positive;
                Mode   : in End_Mode := Normal);

  procedure Get_Word(Varstr   : in out Varstring;
		     Length   : in Positive;
		     Pattern  : in String := " :.,?!");
  procedure Get_Word(File       : in File_Type;
		     Varstr   : in out Varstring;
		     Length   : in Positive;
		     Pattern  : in String := " :.,?!");

  procedure Get_Line(Varstr     : in out Varstring;
                     Max_Length : in Positive := 256;
                     Mode       : in End_Mode := Normal);
  procedure Get_Line(File       : in File_Type;
                     Varstr     : in out Varstring;
                     Max_Length : in Positive := 256;
                     Mode       : in End_Mode := Normal);

--===========================================================================
-- La lecture en ignorant les caracteres souhaites
--===========================================================================
  procedure Selective_Get(Str    : in out String;
                          Ignore : in String := " ");
  procedure Selective_Get(File   : in File_Type;
                          Str    : in out String;
                          Ignore : in String := " ");
  -- Ces deux procedures lisent exactement le nombre de caracteres
  -- necessaires pour remplir str, tout en ignorant les caracteres
  -- presents dans Ignore.

end Strlib.IO;
