--------------------------------------------------------------------------
-- Yaap_Read                                Copyrigth ENS ULM 1996-1999 --
-- Pierre VINCENS                   V 01.000                 1703/1999 --
--------------------------------------------------------------------------
-- Interface de lecture des squences
--------------------------------------------------------------------------
with Ada.Unchecked_Conversion;
with Ada.Text_Io; use  Ada.Text_Io;

with Type_specifications; use Type_Specifications;
with Strlib; use Strlib;

with Sequence_Specifications; use Sequence_Specifications;
with Sequence_Specifications.Basic; use Sequence_Specifications.Basic;

package Yaap_Read is

  Invalid_Access : exception;
  -- Lev dans Read_List_Of_Sequences si les pointeurs Sequences
  -- et R_Sequences ne sont pas null

  procedure Read_One_Sequence(Name          : in String;
                              Identifier    : in Varstring;
                              Model         : in Sequence_Model;
                              Format        : in Sequence_Format;
                              Start, Stop   : in Integer;
			      Strand        : in Strand_Type;
                              Sequence      : in out Sequence_Data;
                              RC_Sequence   : in out Sequence_Data;
                              Opposite      : in Boolean := False;
                              Complementary : in Boolean := False;
			      Verbose       : in Boolean := False);
  -- Lecture d'une sequence dans le fichier specifie 
  -- Strand permet de spcifier quel brin on doit construire.
  -- Les valeurs lgales sont Watson, Crick et Both.
  -- Le brin Watson est retourn dans Sequence, le Crick dans RC_Sequence
  -- Attention, quelle que soit la valeur demande, le brin Watson
  -- est toujours retourn.

  procedure Read_List_Of_Sequences(Name        : in String;
				   Sequences   : in out Sequence_Array_Access;
				   R_Sequences : in out Sequence_Array_Access;
				   Verbose     : in Boolean := False);
  -- Les squences sont lues d'aprs les instructions d'un fichier
  -- Le format de ce fichier est le suivant:
  --  Nom_Sequence Format Brin Identificateur Debut Fin
  -- Le blanc est un sparateur. Un diese en debut de ligne specifie une 
  -- ligne de commentaire.


end Yaap_Read;
